/*
 *  udp client program.
 */
#include <stdio.h>
#include <stdlib.h>

#include <libsclient.h>

/*#define MAXMESG 512 YMA 3/3/98 */
#define MAXMESG 1024

void get_key(Socket *sock, char *tname, Side side)
{
	char c ;
	char buf[MAXMESG] ;
	double pos_x, pos_y ;
	SensorInfo info ;
	PosState pstate ;
	int i ;
	double dir;
	

	while(TRUE) {
		c = (char)fgetc(stdin) ;
		if (c == 'k')
			send_com_dash(sock, 50) ;
		else if (c == 'j')
			send_com_dash(sock, -10) ;
		else if (c == 'b')
		  send_com_body_state(sock); /* added by YMA 2/27/98 */
		else if (c == 'g')
		  send_com_match_state(sock); /* added by YMA 2/27/98 */
		else if (c == 'f')
		  send_com_field_state(sock); /* added by YMA 2/27/98 */
		else if (c == 'h')
			send_com_turn(sock, -10) ;
		else if (c == 'l')
			send_com_turn(sock, 10) ;
		else if (c == ' ')
			send_com_kick(sock, 50, 0) ;
		else if (c == 'c') {
			printf("which direction to jumb? ") ;
			scanf("%lf", &dir) ;
			printf("catch in this direction:  %f\n", dir) ;
			if (!send_com_catch(sock, dir)) 
			  fprintf(stderr,"Cannot send catch command\n");
		}
		else if (c == 'm') {
			printf("where to move? ") ;
			scanf("%lf %lf", &pos_x, &pos_y) ;
			printf("move to %f %f\n", (double)pos_x, (double)pos_y) ;
			send_com_move(sock, (double)pos_x, (double)pos_y) ;
		}
		else if (c == 'p') {
			if (receive_info(sock, buf, sizeof(buf)))
				if (scan_info(buf, &info, tname))
					if (estimate_current_pos(&(info.info.see), side, &pstate))
						printf("pos: (%f, %f), %f\n",
							pstate.pos.x, pstate.pos.y, pstate.dir) ;
					else
					  printf("Can't estimate current pos.\n") ;
							
				else
					printf("Can't scan infomation\n") ;
			else
				printf("Can't reciev infomation\n") ;
		}
		else if (c == 'v') {
			printf("range & quality? {nh|nl|h|l|wh|wl} ") ;
			scanf("%s", buf) ;
			if (!strcmp(buf, "nh")) {
				send_com_change_view(sock, VW_Narrow, VQ_high) ;
				printf("change view to Narrow High.\n ") ;
			}
			else if (!strcmp(buf, "nl")) {
				send_com_change_view(sock, VW_Narrow, VQ_low) ;
				printf("change view to Narrow Low.\n ") ;
			}
			else if (!strcmp(buf, "h")) {
				send_com_change_view(sock, VW_Normal, VQ_high) ;
				printf("change view to Normal High.\n ") ;
			}
			else if (!strcmp(buf, "l")) {
				send_com_change_view(sock, VW_Normal, VQ_low) ;
				printf("change view to Normal Low.\n ") ;
			}
			else if (!strcmp(buf, "wh")) {
				send_com_change_view(sock, VW_Wide, VQ_high) ;
				printf("change view to Wide High.\n ") ;
			}
			else if (!strcmp(buf, "wl")) {
				send_com_change_view(sock, VW_Wide, VQ_low) ;
				printf("change view to Wide Low.\n ") ;
			}
		}
		else if (c == 's') {
			printf("say message? >> ") ;
			scanf("%s", buf) ;
			send_com_say(sock, buf) ;
		}
		else if (c == 'q')
			return ;
		else if (c == 'd'){
		  for (i = 0 ; i < 10 ; i++){
		    if (receive_info(sock,buf,sizeof(buf)))
		      fprintf(stdout,"<<< i: %d \n%s\n>>>\n",i,buf);
		  }
		}
		else if (c == '?') {
			printf("avelable command is\n") ;
			printf("  k : dash forward (pow is 50).\n") ;
			printf("  j : dash backword (pow is 10).\n") ;
			printf("  c : catch ball with hands - valid for goalie only\n") ;
			printf("  b : to display body_state information.\n") ; /*YMA 2/27/98 */
			printf("  g : to display match_state information.\n") ; /*YMA 2/27/98 */
			printf("  f : to display field_state information.\n") ; /*YMA 2/27/98 */
			printf("  l : turn to left (angle is 10).\n") ;
			printf("  h : turn to right (angle is 10).\n") ;
			printf("  (space key) : kick a ball (power is 50).\n") ;
			printf("  m : move.\n") ;
			printf("  d : write buffer info 10 times.\n");
			printf("  v : change view.\n") ;
			printf("  s : say message.\n") ;
			printf("  i : show infomation.\n") ;
			printf("  p : estimate current position.\n") ;
			printf("  ? : show this help.\n") ;
			printf("  q : quit this program.\n") ;
		}
		else if (c == 'i') {
			if (receive_info(sock, buf, sizeof(buf))) {
				fputs(buf, stdout) ;
				fflush(stdout) ;
				if (scan_info(buf, &info, tname)) {
					printf("scan_info parsed successfully\n") ;
					if (info.type == SIT_See) {
					  display_visual_info(stdout,&(info.info.see));
					}
					else if (info.type == SIT_BState) {
					  display_body_info(stdout,&(info.info.bstate));
					}
					else if (info.type == SIT_Hear) {
						printf("  --- HEAR INFO ---\n") ;
						printf(" time : %d\n", info.info.hear.time) ;
						printf(" type : %d\n", info.info.hear.sender) ;
						printf(" dir  : %f\n", info.info.hear.direction) ;
						printf(" mesg : %s\n", info.info.hear.message) ;
					}
					printf("\n") ;
				}
				else
					printf("Can't scan_info\n") ;
			}
			else
				printf("Can't receive infomation\n") ;
		}
	}
}

void main(int argc, char **argv)
{
    Socket sock ;
	char *server ;
	int port ;
	int version,role ; /* YMA 2/25/98 */
	InitInfo info ;
	char tname[16] ;
	/* --------  Begin Added Code - YMA 2/25/98 --------------- */
	
	if (argc == 6) {
	  strcpy(tname, argv[1]) ;
	  server = argv[2] ;
	  port = atoi(argv[3]) ;
	  version = atoi(argv[4]) ;
	  role = atoi(argv[5]);
	}
	else if (argc == 5) {
	  strcpy(tname, argv[1]) ;
	  server = argv[2] ;
	  port = atoi(argv[3]) ;
	  version = atoi(argv[4]) ;
	}
	else {
	  version = 4 ;
	  role = 1 ;
	  /* ----------- End of Added Code - YMA 2/25/98 --------- */	  
	  if(argc == 4) {
	    strcpy(tname, argv[1]) ;
	    server = argv[2] ;
	    port = atoi(argv[3]) ;
	  } else if (argc == 3) {
	    strcpy(tname, argv[1]) ;
	    server = argv[2] ;
	    port = 6000 ;
	  } else if (argc == 2) {
	    strcpy(tname, argv[1]) ;
	    server = "localhost" ;
	    port = 6000 ;
	  } else {
	    printf("usage: %s TEAMNAME [HOST [PORT [VERSION [ROLE]]]]\n", argv[0]) ;
	    exit(0) ;
	  }
	} /* YMA 2/25/98 */
	
    sock = init_connection(server,port) ;
    if(sock.socketfd == -1)
		exit(1) ;

    /*	info = send_com_init(&sock, tname) ; YMA 2/25/98 */
	info = send_com_init(&sock, tname,version,role) ;

	printf("\ninit!: %d, %d, %s, %d\n\n",
		info.side, info.unum, info.playmodestr, info.playmode) ;

	if (info.side == S_UNKNOWN) {
		printf("Can't init\n") ;
		exit(-1) ;
	}
	get_key(&sock, tname, info.side) ;

    close_connection(sock) ;
}











